From 58aa01de46e6fc5b917f9a28355cd68b37e8de5a Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Mon, 30 May 2022 17:15:44 +0200
Subject: [PATCH] misc: move custom authentication titles to dedicated block
 (#65803)

---
 static/roannais-icitoyen/_custom.scss                       | 3 ---
 templates/authentic2/login_password_registration_form.html  | 5 ++++-
 templates/registration/registration_form.html               | 3 ---
 .../authentic2/login_password_registration_form.html        | 6 +-----
 templates/variants/arles-2020/authentic2_auth_fc/login.html | 3 +--
 templates/variants/cnil/authentic2_auth_fc/login.html       | 3 +--
 .../authentic2/login_password_registration_form.html        | 2 +-
 .../roannais-icitoyen/authentic2_auth_fc/login.html         | 4 +---
 .../roannais-icitoyen/authentic2_auth_fc/registration.html  | 5 +++++
 .../rouen/authentic2/login_password_registration_form.html  | 6 +-----
 10 files changed, 15 insertions(+), 25 deletions(-)
 create mode 100644 templates/variants/roannais-icitoyen/authentic2_auth_fc/registration.html

diff --git a/static/roannais-icitoyen/_custom.scss b/static/roannais-icitoyen/_custom.scss
index 0be83114..d1b29018 100644
--- a/static/roannais-icitoyen/_custom.scss
+++ b/static/roannais-icitoyen/_custom.scss
@@ -1041,9 +1041,6 @@ div#rub_service {
 }
 
 #frontend-registration-fc.a2-block {
-	> h2 {
-		display: none;
-	}
 	> div {
 		padding: 0;
 	}
diff --git a/templates/authentic2/login_password_registration_form.html b/templates/authentic2/login_password_registration_form.html
index 67d32a00..fcb1d4d8 100644
--- a/templates/authentic2/login_password_registration_form.html
+++ b/templates/authentic2/login_password_registration_form.html
@@ -1,9 +1,12 @@
 {% extends "authentic2/login_password_registration_form.html" %}
 {% load i18n %}
 
+{% block title %}
+<h2>{% trans "Registration" %}</h2>
+{% endblock %}
+
 {% block registration %}
 {% block registration-password-form-pre %}
-<h2>{% trans "Registration" %}</h2>
 <p>
   Après validation de votre adresse électronique, il vous sera envoyé un courriel
   pour ouvrir votre compte.
diff --git a/templates/registration/registration_form.html b/templates/registration/registration_form.html
index 1ff8537a..a2bd13ed 100644
--- a/templates/registration/registration_form.html
+++ b/templates/registration/registration_form.html
@@ -21,10 +21,7 @@
        {{ block.content|safe }}
    {% else %}
       <div id="frontend-registration-{{ id }}" class="a2-block">
-        <h2>{{ block.name }}</h2>
-        <div>
           {{ block.content|safe }}
-        </div>
    {% endif %}
   </div>
 {% endfor %}
diff --git a/templates/variants/arles-2020/authentic2/login_password_registration_form.html b/templates/variants/arles-2020/authentic2/login_password_registration_form.html
index 11db2395..423feb58 100644
--- a/templates/variants/arles-2020/authentic2/login_password_registration_form.html
+++ b/templates/variants/arles-2020/authentic2/login_password_registration_form.html
@@ -1,9 +1,5 @@
 {% extends "authentic2/login_password_registration_form.html" %}
 
-{% block registration-password-form-pre %}
+{% block title %}
 <h2>Je crée mon compte avec mon adresse électronique</h2>
-<p>
-  Après validation de votre adresse électronique, il vous sera envoyé un courriel
-  pour ouvrir votre compte.
-</p>
 {% endblock %}
diff --git a/templates/variants/arles-2020/authentic2_auth_fc/login.html b/templates/variants/arles-2020/authentic2_auth_fc/login.html
index 31490d4e..c1d052fd 100644
--- a/templates/variants/arles-2020/authentic2_auth_fc/login.html
+++ b/templates/variants/arles-2020/authentic2_auth_fc/login.html
@@ -1,7 +1,6 @@
 {% extends "authentic2_auth_fc/login.html" %}
 {% load i18n %}
 
-{% block login %}
+{% block title %}
 <h3>Je m’identifie avec FranceConnect</h3>
-{{ block.super }}
 {% endblock %}
diff --git a/templates/variants/cnil/authentic2_auth_fc/login.html b/templates/variants/cnil/authentic2_auth_fc/login.html
index 5afe1da4..507b376a 100644
--- a/templates/variants/cnil/authentic2_auth_fc/login.html
+++ b/templates/variants/cnil/authentic2_auth_fc/login.html
@@ -1,6 +1,5 @@
 {% extends "authentic2_auth_fc/login.html" %}
 
-{% block login %}
+{% block title %}
 <h2>S’identifier avec FranceConnect</h2>
-{{ block.super }}
 {% endblock %}
diff --git a/templates/variants/grenoble-metropole-2019/authentic2/login_password_registration_form.html b/templates/variants/grenoble-metropole-2019/authentic2/login_password_registration_form.html
index ab8a4389..895dd139 100644
--- a/templates/variants/grenoble-metropole-2019/authentic2/login_password_registration_form.html
+++ b/templates/variants/grenoble-metropole-2019/authentic2/login_password_registration_form.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/login_password_registration_form.html" %}
 
-{% block registration-password-form-pre %}
+{% block title %}
 <h2>CRÉEZ VOTRE COMPTE</h2>
 {% endblock %}
diff --git a/templates/variants/roannais-icitoyen/authentic2_auth_fc/login.html b/templates/variants/roannais-icitoyen/authentic2_auth_fc/login.html
index 9ffcb13e..0bd04a50 100644
--- a/templates/variants/roannais-icitoyen/authentic2_auth_fc/login.html
+++ b/templates/variants/roannais-icitoyen/authentic2_auth_fc/login.html
@@ -1,7 +1,5 @@
 {% extends "authentic2_auth_fc/login.html" %}
 {% load i18n %}
 
-{% block login %}
-<h2>Je m’identifie avec FranceConnect</h2>
-{{ block.super }}
+{% block title %}
 {% endblock %}
diff --git a/templates/variants/roannais-icitoyen/authentic2_auth_fc/registration.html b/templates/variants/roannais-icitoyen/authentic2_auth_fc/registration.html
new file mode 100644
index 00000000..9eb52653
--- /dev/null
+++ b/templates/variants/roannais-icitoyen/authentic2_auth_fc/registration.html
@@ -0,0 +1,5 @@
+{% extends "authentic2_auth_fc/registration.html" %}
+
+{% block title %}
+<h2>Je m’identifie avec FranceConnect</h2>
+{% endblock %}
diff --git a/templates/variants/rouen/authentic2/login_password_registration_form.html b/templates/variants/rouen/authentic2/login_password_registration_form.html
index 2ed2819a..a1337349 100644
--- a/templates/variants/rouen/authentic2/login_password_registration_form.html
+++ b/templates/variants/rouen/authentic2/login_password_registration_form.html
@@ -1,9 +1,5 @@
 {% extends "authentic2/login_password_registration_form.html" %}
 
-{% block registration-password-form-pre %}
+{% block title %}
 <h2>avec un courrier électronique</h2>
-<p>
-  Après validation de votre adresse électronique, il vous sera envoyé un courriel
-  pour ouvrir votre compte.
-</p>
 {% endblock %}
-- 
2.36.1