From 29455645d8b27429b9e31bc09dc4a0e1cf9c61f2 Mon Sep 17 00:00:00 2001
From: Benjamin Dauvergne <bdauvergne@entrouvert.com>
Date: Wed, 1 Jun 2022 11:15:23 +0200
Subject: [PATCH] alpes-maritimes-2018: add template and image for the CD06
 ADFS button (#64671)

---
 static/alpes-maritimes-2018/_custom.scss        |  11 +++++++++++
 .../img/btn-connexion-agent-cd06.png            | Bin 0 -> 14469 bytes
 .../authentic2_auth_saml/login_cd06-adfs.html   |  12 ++++++++++++
 3 files changed, 23 insertions(+)
 create mode 100644 static/alpes-maritimes-2018/img/btn-connexion-agent-cd06.png
 create mode 100644 templates/variants/alpes-maritimes-2018/authentic2_auth_saml/login_cd06-adfs.html

diff --git a/static/alpes-maritimes-2018/_custom.scss b/static/alpes-maritimes-2018/_custom.scss
index b75fb5e7..46e76bc4 100644
--- a/static/alpes-maritimes-2018/_custom.scss
+++ b/static/alpes-maritimes-2018/_custom.scss
@@ -788,10 +788,21 @@ h2 + h2 {
 			color: #fff;
 			background: $primary-color;
 		}
+		button.cd06-adfs {
+			width: 310px;
+			height: 92px;
+			border: 0;
+			background: url('img/btn-connexion-agent-cd06.png') center no-repeat;
+			box-shadow: none;
+		}
 		a {
 			font-style: italic;
 		}
 	}
+	.block-saml_cd06-adfs {
+		display: flex;
+		justif-content: center;
+	}
 }
 
 div#fc-button-wrapper div#fc-button {
diff --git a/static/alpes-maritimes-2018/img/btn-connexion-agent-cd06.png b/static/alpes-maritimes-2018/img/btn-connexion-agent-cd06.png
new file mode 100644
index 0000000000000000000000000000000000000000..2a7ff295c91cbd3a29826f9e82361011922975dd
GIT binary patch
diff --git a/templates/variants/alpes-maritimes-2018/authentic2_auth_saml/login_cd06-adfs.html b/templates/variants/alpes-maritimes-2018/authentic2_auth_saml/login_cd06-adfs.html
new file mode 100644
index 00000000..80a14269
--- /dev/null
+++ b/templates/variants/alpes-maritimes-2018/authentic2_auth_saml/login_cd06-adfs.html
@@ -0,0 +1,12 @@
+{% extends "authentic2_auth_saml/login.html" %}
+{% load i18n static %}
+
+{% block login %}
+<!-- <p>Vous êtes agent et disposez d'un compte dans l'annuaire du département des Bouches-du-Rhône.</p> -->
+<form method="post">
+    <button class="submit-button cd06-adfs" name="{{ submit_name }}" title="{% trans "Login" %}"></button>
+    {% if cancel %}
+        <button class="cancel-button" name="cancel" formnovalidate>{% trans 'Cancel' %}</button>
+    {% endif %}
+</form>
+{% endblock %}
-- 
2.36.1