From f7aece4a3ffa40f78170b4ea8b4891656a47a635 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Tue, 31 May 2022 10:49:22 +0200
Subject: [PATCH] fonts: add IBM Plex Serif (#65690)

---
 README                                        |   7 +++++
 .../fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff | Bin 0 -> 62924 bytes
 .../IbmPlexSerif/IBMPlexSerif-Bold.woff2      | Bin 0 -> 53896 bytes
 .../IbmPlexSerif/IBMPlexSerif-BoldItalic.woff | Bin 0 -> 67684 bytes
 .../IBMPlexSerif-BoldItalic.woff2             | Bin 0 -> 57616 bytes
 .../IbmPlexSerif/IBMPlexSerif-ExtraLight.woff | Bin 0 -> 64332 bytes
 .../IBMPlexSerif-ExtraLight.woff2             | Bin 0 -> 54828 bytes
 .../IBMPlexSerif-ExtraLightItalic.woff        | Bin 0 -> 68424 bytes
 .../IBMPlexSerif-ExtraLightItalic.woff2       | Bin 0 -> 58312 bytes
 .../IbmPlexSerif/IBMPlexSerif-Italic.woff     | Bin 0 -> 67640 bytes
 .../IbmPlexSerif/IBMPlexSerif-Italic.woff2    | Bin 0 -> 57500 bytes
 .../IbmPlexSerif/IBMPlexSerif-Light.woff      | Bin 0 -> 64704 bytes
 .../IbmPlexSerif/IBMPlexSerif-Light.woff2     | Bin 0 -> 55156 bytes
 .../IBMPlexSerif-LightItalic.woff             | Bin 0 -> 69812 bytes
 .../IBMPlexSerif-LightItalic.woff2            | Bin 0 -> 59012 bytes
 .../IbmPlexSerif/IBMPlexSerif-Medium.woff     | Bin 0 -> 66068 bytes
 .../IbmPlexSerif/IBMPlexSerif-Medium.woff2    | Bin 0 -> 56480 bytes
 .../IBMPlexSerif-MediumItalic.woff            | Bin 0 -> 72488 bytes
 .../IBMPlexSerif-MediumItalic.woff2           | Bin 0 -> 61192 bytes
 .../IbmPlexSerif/IBMPlexSerif-Regular.woff    | Bin 0 -> 62472 bytes
 .../IbmPlexSerif/IBMPlexSerif-Regular.woff2   | Bin 0 -> 53248 bytes
 .../IbmPlexSerif/IBMPlexSerif-SemiBold.woff   | Bin 0 -> 66336 bytes
 .../IbmPlexSerif/IBMPlexSerif-SemiBold.woff2  | Bin 0 -> 56456 bytes
 .../IBMPlexSerif-SemiBoldItalic.woff          | Bin 0 -> 72188 bytes
 .../IBMPlexSerif-SemiBoldItalic.woff2         | Bin 0 -> 61276 bytes
 .../fonts/IbmPlexSerif/IBMPlexSerif-Text.woff | Bin 0 -> 65896 bytes
 .../IbmPlexSerif/IBMPlexSerif-Text.woff2      | Bin 0 -> 56028 bytes
 .../IbmPlexSerif/IBMPlexSerif-TextItalic.woff | Bin 0 -> 72080 bytes
 .../IBMPlexSerif-TextItalic.woff2             | Bin 0 -> 61084 bytes
 .../fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff | Bin 0 -> 58840 bytes
 .../IbmPlexSerif/IBMPlexSerif-Thin.woff2      | Bin 0 -> 50408 bytes
 .../IbmPlexSerif/IBMPlexSerif-ThinItalic.woff | Bin 0 -> 61344 bytes
 .../IBMPlexSerif-ThinItalic.woff2             | Bin 0 -> 52112 bytes
 static/includes/fonts/_ibm-plex-serif.scss    |  24 ++++++++++++++++++
 34 files changed, 31 insertions(+)
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff2
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff
 create mode 100644 static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff2
 create mode 100644 static/includes/fonts/_ibm-plex-serif.scss

diff --git a/README b/README
index 6066455f..c530219f 100644
--- a/README
+++ b/README
@@ -376,6 +376,13 @@ copyright notices:
   #
   # https://github.com/rsms/inter
 
+* IBM Plex Serif
+  # Copyright © 2017 IBM Corp. with Reserved Font Name "Plex".
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/fonts/ibm-plex
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..0049d97c718021a48e90a3338630fbd649687db0
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Bold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..0233374bd3fce7f5b80868b4ca99a7144b23cba6
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..e9f06b1aaa95fc26d6310f0ec6384a83a8eb44ff
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-BoldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d72a45453cb141b504e8adda4c379e96b2c4b3b3
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff
new file mode 100644
index 0000000000000000000000000000000000000000..091fd8ca8ab8da5ee3a01c915c195ce0c9ad33b7
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLight.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2932fc6d1b456061b2b759dcc20381607122d045
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..1a500eb32ef8b0fa77c1c85482a72ce7cfa1204d
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-ExtraLightItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..e11d5ad658c14a186407917ccf1e313c0a4b1306
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..079e97ba903d384892240e9e13b97ddfad676c43
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Italic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3520e35aca1f54ce9fa38d8b68aa26cfbf178013
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ccecb46bf898b1f13879317fd35dd5c5fb4a6446
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Light.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..0506819a9562e198ff19af8e38d0c44cddcc6005
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..540b916366be1194c6413e97dda045c2a112b062
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-LightItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c907c75f943a8d2302bd6acee734b2bde47c08a1
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff
new file mode 100644
index 0000000000000000000000000000000000000000..48e19f0f5e85b4324fd949682f2ba348f038cb22
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Medium.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..b3ef22e14eb829baaa93d2d66e1c68da3af59912
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..fc436c097944133ccd63afb667108fe08431ba5c
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-MediumItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..de8a156d69229fa8ab9c76b86a085c685fc43b81
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff
new file mode 100644
index 0000000000000000000000000000000000000000..55caeed9c80045d211a9783770126d867f19d499
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Regular.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..37789af42620effbf40fbafd738db3afa8379db6
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..93ad6732dab43be3eb3bae30f03b2e2d8bef067e
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..02d6a9b7828f9bb637214f173c8262886c2f9139
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d5237adb87788d6e480cf72a65442e0871c2e1cb
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-SemiBoldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c44c06741883aa124aaf658ab2042c7678402205
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff
new file mode 100644
index 0000000000000000000000000000000000000000..309056a28b1de540f527f1ad357cacb2db51647e
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Text.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..6dec79c4a1ffbf03c036d3710cc8dfd9a3bbfeff
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..53c63a5b4d6bbc2f20e8cf6aa323d1f5a1dfa7e9
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-TextItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a43525f2479af36074acfada245a8548a180c2a3
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff
new file mode 100644
index 0000000000000000000000000000000000000000..f4246e4cf31d0838cccb31689df81acd9223d93c
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-Thin.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..cbe50807824cbcb9971747711047532769f18eae
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff b/static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..022c4ebe3fd7df6d2328ee7e972b27b88bd2338f
GIT binary patch
diff --git a/static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff2 b/static/fonts/IbmPlexSerif/IBMPlexSerif-ThinItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..ec478aadcf0c466ab2c6965cfe127bfa2a31f717
GIT binary patch
diff --git a/static/includes/fonts/_ibm-plex-serif.scss b/static/includes/fonts/_ibm-plex-serif.scss
new file mode 100644
index 00000000..72e949a3
--- /dev/null
+++ b/static/includes/fonts/_ibm-plex-serif.scss
@@ -0,0 +1,24 @@
+@mixin ibm-font($type, $weight, $style) {
+	@font-face {
+		font-family: 'IBM Plex Serif';
+		src: url('/static/fonts/IbmPlexSerif/IBMPlexSerif-#{$type}.woff2') format('woff2'),
+		     url('/static/fonts/IbmPlexSerif/IBMPlexSerif-#{$type}.woff') format('woff');
+		font-weight: $weight;
+		font-style: $style;
+	}
+}
+
+@mixin ibm-font-pair($type, $weight) {
+	@include ibm-font($type, $weight, normal);
+	@include ibm-font('#{$type}Italic', $weight, italic);
+}
+
+@include ibm-font-pair('Thin', 100);
+@include ibm-font-pair('ExtraLight', 200);
+@include ibm-font-pair('Light', 300);
+@include ibm-font-pair('Medium', 500);
+@include ibm-font-pair('SemiBold', 600);
+@include ibm-font-pair('Bold', 700);
+@include ibm-font-pair('Text', 400);
+@include ibm-font('Regular', 400, normal);
+@include ibm-font('Italic', 400, italic);
-- 
2.36.1